<?php

require_once dirname(__FILE__) . '/../../../SEI.php';

/**
 * Cria uma tabela de relao 1 para 1 para unidade com o intuito de adicionar
 * novos campos de configurao para cada unidade utilizado somente pelo mdulo
 * PEN
 * 
 * Crio a classe com extendida de UnidadeDTO em funo dos mtodos de UnidadeRN,
 * que fora o hinting para UnidadeDTO, ento no gera erro usar PenUnidadeDTO
 * com o UnidadeBD e UnidadeRN
 * 
 * @author Join Tecnologia
 * @see http://php.net/manual/pt_BR/language.oop5.typehinting.php
 */
class PenUnidadeDTO extends UnidadeDTO {

    public function getStrNomeTabela() {
        return 'md_pen_unidade';
    }
    
    public function montar() {
        
        $this->adicionarAtributoTabela(InfraDTO::$PREFIXO_NUM, 'IdUnidade', 'id_unidade'); 
        $this->adicionarAtributoTabela(InfraDTO::$PREFIXO_NUM, 'IdUnidadeRH', 'id_unidade_rh'); 
        $this->configurarPK('IdUnidade',InfraDTO::$TIPO_PK_INFORMADO);
        
        // Infelizmente no funciona com parent::getArrAtributos(), pois o arrAtributos
        // esta na InfraDTO e ela confunde em funo do extends, ento tenho que 
        // criar uma nova instncia
        $objUnidadeDTO = new UnidadeDTO();
        $objUnidadeDTO->retTodos();
        
        foreach($objUnidadeDTO->getArrAtributos() as $arrAtrib) {
            
            if($arrAtrib[InfraDTO::$POS_ATRIBUTO_PREFIXO] != 'IdUnidade') {
            
                $this->adicionarAtributoTabelaRelacionada(
                    $arrAtrib[InfraDTO::$POS_ATRIBUTO_PREFIXO], 
                    $arrAtrib[InfraDTO::$POS_ATRIBUTO_NOME], 
                    $arrAtrib[InfraDTO::$POS_ATRIBUTO_CAMPO_SQL], 
                    $objUnidadeDTO->getStrNomeTabela()
                );
            }
        }     

        $this->configurarFK('IdUnidade', 'unidade', 'id_unidade');  
    }
}
